//---------------------------------------------------------------------------
//
// Name:        SaveAsTextureDlg.cpp
// Author:      i-saint
// Created:     2005/04/26 10:44:42
//
//---------------------------------------------------------------------------

#include "GroundEditorApp.h"
#include "SaveAsTextureDlg.h"

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
////Header Include End



//----------------------------------------------------------------------------
// SaveAsTextureDlg
//----------------------------------------------------------------------------
     //Add Custom Events only in the appropriate Block.
    // Code added in  other places will be removed by wx-dvcpp 
    ////Event Table Start
BEGIN_EVENT_TABLE(SaveAsTextureDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(SaveAsTextureDlg::SaveAsTextureDlgClose)
	EVT_PAINT(SaveAsTextureDlg::SaveAsTextureDlgPaint)
	EVT_TEXT_ENTER(ID_TEWIDTH,SaveAsTextureDlg::BURenderClick)
	EVT_TEXT_ENTER(ID_TEHEIGHT,SaveAsTextureDlg::BURenderClick)
	EVT_BUTTON(ID_BUSAVE,SaveAsTextureDlg::BUOkClick)
	EVT_BUTTON(ID_BURENDER,SaveAsTextureDlg::BURenderClick)
END_EVENT_TABLE()
    ////Event Table End



SaveAsTextureDlg::SaveAsTextureDlg( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxDialog( parent, id, title, position, size, style)
{
    CreateGUIControls();
}

SaveAsTextureDlg::~SaveAsTextureDlg() {} 

void SaveAsTextureDlg::CreateGUIControls(void)
{
    //Do not add custom Code here
    //wx-devcpp designer will remove them.
    //Add the custom code before or after the Blocks
    ////GUI Items Creation Start

	this->SetSize(8,8,592,542);
	this->SetTitle(_("Save As Texture"));
	this->Center();
	this->SetIcon(wxNullIcon);
	

	TEWidth =  new wxTextCtrl(this, ID_TEWIDTH, _("512") , wxPoint(2,6),wxSize(41,21)  , wxTE_PROCESS_ENTER);
	TEWidth->SetMaxLength(0);
	TEWidth->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	TEHeight =  new wxTextCtrl(this, ID_TEHEIGHT, _("512") , wxPoint(2,30),wxSize(41,21)  , wxTE_PROCESS_ENTER);
	TEHeight->SetMaxLength(0);
	TEHeight->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	BUSave =  new wxButton(this, ID_BUSAVE, _("save") , wxPoint(1,88),wxSize(43,25) );
	BUSave->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	BURender =  new wxButton(this, ID_BURENDER, _("render") , wxPoint(1,59),wxSize(43,25) );
	BURender->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));
    ////GUI Items Creation End
}

void SaveAsTextureDlg::SaveAsTextureDlgClose(wxCloseEvent& event)
{
    // --> Don't use Close with a wxDialog,
    // use Destroy instead.
    Destroy();
}


void SaveAsTextureDlg::SetCanvas(wxGLCanvas *p)
{
	canvas = new wxGLCanvas(this, p);
	canvas->SetSize(50, 0, 512, 512);
}

void SaveAsTextureDlg::Render()
{
	long w(0), h(0);
	if(GetWH(w, h)) {
		canvas->SetCurrent();
		GetGEApp().drawAsTexture(w, h);
		canvas->SwapBuffers();
	}
}

bool SaveAsTextureDlg::GetWH(long& w, long& h)
{
	if(TEWidth->GetValue().ToLong(&w) && TEHeight->GetValue().ToLong(&h))
		return true;
	return false;
}

/*
 * BUOkClick
 */
void SaveAsTextureDlg::BUOkClick(wxCommandEvent& event)
{
	// insert your code here

	wxFileDialog file_dlg(this, _T("save"), _T(""), _T(""),
		_T("png file (*.png)|*.png"),
		wxSAVE | wxOVERWRITE_PROMPT );
	if(file_dlg.ShowModal()==wxID_OK) {
		long w(0), h(0);
		if(GetWH(w, h)) {
			canvas->SetCurrent();
			Render();
			GetGEApp().saveAsTexture(file_dlg.GetPath().c_str(), w, h);
		}
	}
	event.Skip();
}

/*
 * BURenderClick
 */
void SaveAsTextureDlg::BURenderClick(wxCommandEvent& event)
{
	// insert your code here
	
	long w(0), h(0);
	if(GetWH(w, h)) {
		SetSize(50+w+30, h+30);
		canvas->SetSize(50, 0, w, h);
		Render();
	}
	event.Skip();
}

/*
 * SaveAsTextureDlgPaint
 */
void SaveAsTextureDlg::SaveAsTextureDlgPaint(wxPaintEvent& event)
{
	// insert your code here
	Render();
	event.Skip();
}
