//---------------------------------------------------------------------------
//
// Name:        SaveAsTextureDlg.h
// Author:      i-saint
// Created:     2005/04/26 10:44:42
//
//---------------------------------------------------------------------------
#ifndef __SAVEASTEXTUREDLG_HPP_
#define __SAVEASTEXTUREDLG_HPP_


// For compilers that support precompilation, includes "wx.h".
#include <wx/wxprec.h>

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
// Include your minimal set of headers here, or wx.h
#include <wx/wx.h>
#endif


//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
#include <wx/textctrl.h>
#include <wx/button.h>
////Header Include End

#include <wx/dialog.h>
#include <wx/glcanvas.h>

//Compatibility for 2.4.x code
#ifndef wxCLOSE_BOX
#define wxCLOSE_BOX 0x1000
#endif
#ifndef wxFIXED_MINSIZE
#define wxFIXED_MINSIZE 0
#endif

////Dialog Style Start
	#define THIS_DIALOG_STYLE wxCAPTION | wxRESIZE_BORDER | wxSYSTEM_MENU | wxDIALOG_NO_PARENT | wxMINIMIZE_BOX | wxMAXIMIZE_BOX |  wxCLOSE_BOX
////Dialog Style End

class SaveAsTextureDlg : public wxDialog
{
public:
    SaveAsTextureDlg( wxWindow *parent, wxWindowID id = 1, const wxString &title = _T("Untitled2"),
        const wxPoint& pos = wxDefaultPosition,
        const wxSize& size = wxDefaultSize,
        long style = THIS_DIALOG_STYLE);
    virtual ~SaveAsTextureDlg();

public:

  //Do not add custom Control Declarations here.
  //wx-devcpp will remove them. Try adding the custom code 
  //after the block.
  ////GUI Control Declaration Start
	wxTextCtrl *TEWidth;
	wxTextCtrl *TEHeight;
	wxButton *BUSave;
	wxButton *BURender;
  ////GUI Control Declaration End

private:
    DECLARE_EVENT_TABLE()

public:
    //Note: if you receive any error with these enums, then you need to
    //change your old form code that are based on the #define control ids.
    //#defines may replace a numeric value for the enums names.
    //Try copy pasting the below block in your old Form header Files.
	enum {
////GUI Enum Control ID Start
ID_TEWIDTH = 1046 ,
ID_TEHEIGHT = 1049 ,
ID_BUSAVE = 1048 ,
ID_BURENDER = 1047 ,
////GUI Enum Control ID End
   ID_DUMMY_VALUE_ //Dont Delete this DummyValue
   }; //End of Enum

public:
	void SetCanvas(wxGLCanvas *p);
	void Render();
	bool GetWH(long& w, long& h);
	wxGLCanvas *canvas;

public:
    void SaveAsTextureDlgClose(wxCloseEvent& event);
    void CreateGUIControls(void);
	void BUOkClick(wxCommandEvent& event);
	void BURenderClick(wxCommandEvent& event);
	void SaveAsTextureDlgPaint(wxPaintEvent& event);

};


#endif
 
 
 
 
