//---------------------------------------------------------------------------
//
// Name:        HeightDlg.cpp
// Author:      i-saint
// Created:     2005/04/24 13:28:13
//
//---------------------------------------------------------------------------

#include "UVRangeDlg.h"
#include "GroundEditorApp.h"

//Do not add custom headers.
//wx-dvcpp designer will remove them
////Header Include Start
////Header Include End



//----------------------------------------------------------------------------
// HeightDlg
//----------------------------------------------------------------------------
     //Add Custom Events only in the appropriate Block.
    // Code added in  other places will be removed by wx-dvcpp 
    ////Event Table Start
BEGIN_EVENT_TABLE(UVRangeDlg,wxDialog)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(UVRangeDlg::HeightDlgClose)
	EVT_BUTTON(ID_BUFIT,UVRangeDlg::BUFitClick)
	EVT_TEXT_ENTER(ID_TEHIGH,UVRangeDlg::TELowEnter)
	EVT_TEXT_ENTER(ID_TELOW,UVRangeDlg::TELowEnter)
	EVT_BUTTON(ID_BUOK,UVRangeDlg::BUOkClick)
END_EVENT_TABLE()
    ////Event Table End



UVRangeDlg::UVRangeDlg( wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style )
    : wxDialog( parent, id, title, position, size, style)
{
    CreateGUIControls();

	float l=0, h=0;
	GetBrush().getVRange(l, h);
	wxString tmp;
	tmp.Printf("%.1f", l);
	TELow->SetValue(tmp);
	tmp.Printf("%.1f", h);
	TEHigh->SetValue(tmp);
}

UVRangeDlg::~UVRangeDlg() {} 

void UVRangeDlg::CreateGUIControls(void)
{
    //Do not add custom Code here
    //wx-devcpp designer will remove them.
    //Add the custom code before or after the Blocks
    ////GUI Items Creation Start

	this->SetSize(8,8,254,113);
	this->SetTitle(_("texcoord range"));
	this->Center();
	this->SetIcon(wxNullIcon);
	

	BUFit =  new wxButton(this, ID_BUFIT, _("fit") , wxPoint(192,16),wxSize(43,25) );
	BUFit->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText2 =  new wxStaticText(this, ID_WXSTATICTEXT2 ,_("high") ,wxPoint(96,16),wxSize(24,17)  );
	WxStaticText2->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticText1 =  new wxStaticText(this, ID_WXSTATICTEXT1 ,_("low") ,wxPoint(8,16),wxSize(20,17)  );
	WxStaticText1->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	TEHigh =  new wxTextCtrl(this, ID_TEHIGH, _("0") , wxPoint(120,16),wxSize(57,21)  , wxTE_PROCESS_ENTER);
	TEHigh->SetMaxLength(0);
	TEHigh->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	TELow =  new wxTextCtrl(this, ID_TELOW, _("0") , wxPoint(32,16),wxSize(57,21)  , wxTE_PROCESS_ENTER);
	TELow->SetMaxLength(0);
	TELow->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	BUOk =  new wxButton(this, ID_BUOK, _("ok") , wxPoint(160,56),wxSize(75,25) );
	BUOk->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));

	WxStaticBox1 =  new wxStaticBox(this, ID_WXSTATICBOX1,_("texcoord range"),wxPoint(0,0),wxSize(241,49)  );
	WxStaticBox1->SetFont(wxFont(8, wxSWISS ,wxNORMAL,wxNORMAL,FALSE,_T("MS Sans Serif")));
    ////GUI Items Creation End
}

void UVRangeDlg::HeightDlgClose(wxCloseEvent& event)
{
    // --> Don't use Close with a wxDialog,
    // use Destroy instead.
    Destroy();
}



void UVRangeDlg::execute()
{
	double l=0, h=0;
	if(TELow->GetValue().ToDouble(&l)
	&& TEHigh->GetValue().ToDouble(&h)) {
		GetBrush().setVRange(l, h);
		Destroy();
	}
}

/*
 * BUOkClick
 */
void UVRangeDlg::BUOkClick(wxCommandEvent& event)
{
	// insert your code here
	execute();
	event.Skip();
}

/*
 * TELowEnter
 */
void UVRangeDlg::TELowEnter(wxCommandEvent& event)
{
	// insert your code here
	execute();
	event.Skip();
}

/*
 * BUFitClick
 */
void UVRangeDlg::BUFitClick(wxCommandEvent& event)
{
	// insert your code here
	float l=0, h=0;
	GetGround().getHeightRange(l, h);
	wxString tmp;
	tmp.Printf("%.1f", l);
	TELow->SetValue(tmp);
	tmp.Printf("%.1f", h);
	TEHigh->SetValue(tmp);

	event.Skip();
}
