#!/bin/sh

target=ist.lib
cc=cl
cflag="-MT -O2 -Og -Ob2 -Ot -GA -D_MBCS -FD -GS -DWIN32 -DNDEBUG -DENABLE_GL_EXT -DENABLE_ARB_VBO -DUSE_PNG"


if test $# -ne 0
then
	srcs=`echo $@ | grep -E \.\(cc\|cpp\)`
else
	rm *.obj
	srcs=`ls | grep -E \.\(cc\|cpp\)`
fi

for f in ${srcs}
do
	${cc} -c ${cflag} ${f}
done


echo $target
lib -out:${target} *.obj


