#ifndef GL_POLYGON_MODEL_INCLUDE
#define GL_POLYGON_MODEL_INCLUDE


#include <vector>
#include "polygon_model.h"

namespace ist {
namespace i3d {




class PolygonChunc : public BPolygonChunc
{
public:
	typedef std::vector<float> vertex_array_cont;

	PolygonChunc();
	~PolygonChunc();

	void draw() const;
	void setup();

	vertex_array_cont vertex_array;

protected:
	unsigned int vbo_id;
};


typedef TPolygonModel<PolygonChunc> PolygonModel;


} //gl
} //ist

#endif
