#include "gl_include.h"
#include "i3d_screen_matrix.h"


namespace ist {
namespace i3d {

ScreenMatrix::ScreenMatrix()
{
	int viewport[4];

	glGetIntegerv(GL_VIEWPORT, viewport);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,viewport[2], 0,viewport[3], -1,5000);
//	gluOrtho2D(0,viewport[2], 0,viewport[3]);
	glGetFloatv(GL_PROJECTION_MATRIX, proj_matrix.v);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

ScreenMatrixIV::ScreenMatrixIV()
{
	int viewport[4];

	glGetIntegerv(GL_VIEWPORT, viewport);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,viewport[2], viewport[3],0, -1,5000);
//	gluOrtho2D(0,viewport[2], viewport[3],0);
	glGetFloatv(GL_PROJECTION_MATRIX, proj_matrix.v);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}


} //gl
} //ist

