#ifndef I3D_MATERIAL_INCLUDE
#define I3D_MATERIAL_INCLUDE

#include "vector.h"



namespace ist {
namespace i3d {


class Material
{
public:
	Material();
	void assign() const;

public:
	vector4 ambient;
	vector4 diffuse;
	vector4 specular;
	vector4 emission;
	float shininess;
};


class Color
{
public:
	Color();
	Color(float r, float g, float b, float a);
	void assign() const;

public:
	vector4 color;
};


} //i3d
} //ist

#endif
